package com.test.s3;

import java.util.concurrent.CountDownLatch;
import java.util.function.Consumer;
import lombok.Getter;
import reactor.core.publisher.Flux;
import reactor.core.publisher.FluxSink;

public class ConsumerFeed<T> {
    @Getter
    Consumer<T> dataFeed;
    FluxSink<T> sink;
    final CountDownLatch subscription = new CountDownLatch(1);
    @Getter
    Flux<T> flux = Flux.create(sink -> {
        System.out.println("Create");
        this.sink = sink;
        dataFeed = sink::next;
        subscription.countDown();
    });
    void complete() {
        sink.complete();
    }
}
